<%@ Page Language="vb" AutoEventWireup="false" Codebehind="WebForm1.aspx.vb" Inherits="SysIO.WebForm2"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
	<HEAD>
		<title>WebForm2</title>
		<meta name="GENERATOR" content="Microsoft Visual Studio.NET 7.0">
		<meta name="CODE_LANGUAGE" content="Visual Basic 7.0">
		<meta name="vs_defaultClientScript" content="JavaScript">
		<meta name="vs_targetSchema" content="http://schemas.microsoft.com/intellisense/ie5">
	</HEAD>
	<body>
		<form id="WebForm1" method="post" runat="server">
			<p>This page demonstrates using the Directory class. The buttons below represent 
				a&nbsp;number of operations that you can test.</p>
			<p>All create and delete operations will occur in a special <font color="blue">UserCreatedDirectory</font>
				. You may not specify an absolute page. You also may not specify anything 
				except a single directory name.</p>
			<p>The Current Directory Info button shows information about the SysIO directory 
				which contains all of the demo pages for this chapter.</p>
			<table cellspacing="1" cellpadding="1" width="100%" border="1">
				<tr>
					<td>
						<asp:Label id="Result" runat="server"></asp:Label>
					</td>
				</tr>
			</table>
			<p>
				<table cellspacing="1" cellpadding="1" width="100%" border="1">
					<tr>
						<td width="33%" align="right">
							Directory Name:
						</td>
						<td width="33%" align="left">
							<asp:TextBox id="DirectoryName" runat="server"></asp:TextBox>
						</td>
						<td width="34%" align="middle">
							<asp:Button id="DirectoryExists" runat="server" Text="Directory Exists"></asp:Button>
						</td>
					</tr>
					<tr>
						<td align="middle">
							<asp:Button id="GetDirsInDir" runat="server" Text="Directories in Directory"></asp:Button>
						</td>
						<td align="middle">
							<asp:Button id="GetFilesInDirectory" runat="server" Text="Files in Directory"></asp:Button>
						</td>
						<td align="middle">
							<asp:Button id="GetLogicalDrives" runat="server" Text="Logical Drives"></asp:Button>
						</td>
					</tr>
					<tr>
						<td align="middle">
							<asp:Button id="CurrentDirectoryInfo" runat="server" Text="Current Directory Info"></asp:Button>
						</td>
						<td align="middle">
							<asp:Button id="DeleteDirectory" runat="server" Text="Delete Directory"></asp:Button>
						</td>
						<td align="middle">
							<asp:Button id="CreateDirectory" runat="server" Text="Create Directory"></asp:Button>
						</td>
					</tr>
				</table>
			<P align="center">
				<asp:Button id="Button1" runat="server" Text="Chapter 5 Contents"></asp:Button></P>
		</form>
		<table border="1" width="100%">
			<tr>
				<td width="100%"><font COLOR="#0000ff">Sub</font> CreateDirectory_Click(<font COLOR="#0000ff">ByVal</font>
					sender <font COLOR="#0000ff">As</font> System.Object, <font COLOR="#0000ff">ByVal</font>
					e <font COLOR="#0000ff">As</font> System.EventArgs)
					<p><font COLOR="#008000">&nbsp; ' Call the code that checks for invalid characters.<br>
							&nbsp; </font><font COLOR="#0000ff">If</font> <font COLOR="#0000ff">Not</font>
						IsPathOK() <font COLOR="#0000ff">Then<br>
							&nbsp;&nbsp;&nbsp; Return<br>
						</font>&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">If</font></p>
					<p><font COLOR="#008000">&nbsp; ' Create the directory path.<br>
						</font>&nbsp; <font COLOR="#0000ff">Dim</font> strFilepath <font COLOR="#0000ff">As</font>
						<font COLOR="#0000ff">String<br>
						</font>&nbsp; strFilepath = Server.MapPath("UserCreatedDirectories\" &amp; 
						DirectoryName.Text)</p>
					<p><font COLOR="#008000">&nbsp; ' Create the directory and catch exceptions.<br>
						</font>&nbsp; <font COLOR="#0000ff">Try<br>
						</font>&nbsp;&nbsp;&nbsp; Directory.CreateDirectory(strFilepath)<br>
						&nbsp;&nbsp;&nbsp; Result.Text = "Created: " &amp; strFilepath<br>
						&nbsp; <font COLOR="#0000ff">Catch</font> ex <font COLOR="#0000ff">As</font> Exception<br>
						&nbsp;&nbsp;&nbsp; Result.Text = "Exception: " &amp; ex.Message<br>
						&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Try</p>
					</FONT>
					<p><font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Sub</font></p>
				</td>
			</tr>
			<tr>
				<td width="100%"><font COLOR="#0000ff">Sub</font> DeleteDirectory_Click(<font COLOR="#0000ff">ByVal</font>
					sender <font COLOR="#0000ff">As</font> System.Object, <font COLOR="#0000ff">ByVal</font>
					e <font COLOR="#0000ff">As</font> System.EventArgs)
					<p><font COLOR="#008000">&nbsp; ' Call the code that checks for invalid characters.<br>
						</font>&nbsp; <font COLOR="#0000ff">If</font> <font COLOR="#0000ff">Not</font> IsPathOK()
						<font COLOR="#0000ff">Then<br>
						</font>&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">Return<br>
						</font>&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">If</font></p>
					<p><font COLOR="#008000">&nbsp; ' Create the directory path.<br>
						</font>&nbsp; <font COLOR="#0000ff">Dim</font> strFilepath <font COLOR="#0000ff">As</font>
						<font COLOR="#0000ff">String<br>
						</font>&nbsp; strFilepath = Server.MapPath("UserCreatedDirectories\" &amp; 
						DirectoryName.Text)</p>
					<p><font COLOR="#008000">&nbsp; ' Delete the directory and catch exceptions.<br>
						</font>&nbsp; <font COLOR="#0000ff">Try<br>
						</font>&nbsp;&nbsp;&nbsp; Directory.Delete(strFilepath)<br>
						&nbsp;&nbsp;&nbsp; Result.Text = "Deleted: " &amp; strFilepath<br>
						&nbsp; <font COLOR="#0000ff">Catch</font> ex <font COLOR="#0000ff">As</font> Exception<br>
						&nbsp;&nbsp;&nbsp; Result.Text = "Exception: " &amp; ex.Message<br>
						&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Try</p>
					</FONT>
					<p><font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Sub</font></p>
				</td>
			</tr>
			<tr>
				<td width="100%"><font COLOR="#0000ff">Sub</font> DirectoryExists_Click(<font COLOR="#0000ff">ByVal</font>
					sender <font COLOR="#0000ff">As</font> System.Object, <font COLOR="#0000ff">ByVal</font>
					e <font COLOR="#0000ff">As</font> System.EventArgs)
					<p><font COLOR="#008000">&nbsp; ' Call the code that checks for invalid characters.<br>
						</font>&nbsp; <font COLOR="#0000ff">If</font> <font COLOR="#0000ff">Not</font> IsPathOK()
						<font COLOR="#0000ff">Then<br>
						</font>&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">Return<br>
						</font>&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">If</font></p>
					<p><font COLOR="#008000">&nbsp; ' Create the directory path.<br>
						</font>&nbsp; <font COLOR="#0000ff">Dim</font> strFilepath <font COLOR="#0000ff">As</font>
						<font COLOR="#0000ff">String<br>
						</font>&nbsp; strFilepath = Server.MapPath("UserCreatedDirectories\" &amp; 
						DirectoryName.Text)</p>
					<p><font COLOR="#008000">&nbsp; ' Check the existence the directory and catch 
							exceptions.<br>
						</font>&nbsp; <font COLOR="#0000ff">Try<br>
						</font>&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">If</font> Directory.DirectoryExists(strFilepath) 
						= <font COLOR="#0000ff">True</font> <font COLOR="#0000ff">Then<br>
						</font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Result.Text = strFilepath &amp; " does 
						exist"<br>
						&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">Else<br>
						</font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Result.Text = strFilepath &amp; " does 
						not exist"<br>
						&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">If<br>
						</font>&nbsp; <font COLOR="#0000ff">Catch</font> ex <font COLOR="#0000ff">As</font>
						Exception<br>
						&nbsp;&nbsp;&nbsp; Result.Text = "Exception: " &amp; ex.Message<br>
						&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Try</p>
					</FONT>
					<p><font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Sub</font></p>
				</td>
			</tr>
			<tr>
				<td width="100%"><font COLOR="#0000ff">Sub</font> GetDirsInDir_Click(<font COLOR="#0000ff">ByVal</font>
					sender <font COLOR="#0000ff">As</font> System.Object, <font COLOR="#0000ff">ByVal</font>
					e <font COLOR="#0000ff">As</font> System.EventArgs)
					<p><font COLOR="#0000ff">&nbsp; Dim</font> dl <font COLOR="#0000ff">As</font> String()<br>
						&nbsp; <font COLOR="#0000ff">Dim</font> Item <font COLOR="#0000ff">As</font> String</p>
					<p><font COLOR="#0000ff">&nbsp; Try<br>
						</font>&nbsp;&nbsp;&nbsp; dl = 
						Directory.GetDirectoriesInDirectory(Request.MapPath("UserCreatedDirectories"), 
						"*.*")<br>
						&nbsp;&nbsp;&nbsp; Result.Text = ""</p>
					<p><font COLOR="#0000ff">&nbsp;&nbsp;&nbsp; For</font> <font COLOR="#0000ff">Each</font>
						Item <font COLOR="#0000ff">In</font> dl</p>
					<p><font COLOR="#0000ff">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Dim</font> strDirName <font COLOR="#0000ff">
							As</font> <font COLOR="#0000ff">String<br>
						</font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; strDirName = Item<br>
						&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">Dim</font> nIndex <font COLOR="#0000ff">
							As</font> <font COLOR="#0000ff">Integer<br>
						</font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; nIndex = strDirName.IndexOf("\")</p>
					<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">While</font> nIndex &gt;= 0<br>
						&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; strDirName = Right(strDirName, 
						len(strDirName) - nIndex - 1)<br>
						&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; nIndex = strDirName.IndexOf("\")<br>
						&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">
							While</font></p>
					<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Result.Text = Result.Text &amp; strDirName &amp; 
						"&lt;br&gt;" &amp; Chr(13) &amp; Chr(10)<br>
						&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">Next<br>
						</font>&nbsp; <font COLOR="#0000ff">Catch</font> ex <font COLOR="#0000ff">As</font>
						Exception<br>
						&nbsp;&nbsp;&nbsp; Result.Text = ex.Message<br>
						&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Try</p>
					</FONT>
					<p><font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Sub</font></p>
				</td>
			</tr>
			<tr>
				<td width="100%"><font COLOR="#0000ff">Sub</font> GetFilesInDirectory_Click(<font COLOR="#0000ff">ByVal</font>
					sender <font COLOR="#0000ff">As</font> System.Object, <font COLOR="#0000ff">ByVal</font>
					e <font COLOR="#0000ff">As</font> System.EventArgs)
					<p><font COLOR="#0000ff">&nbsp; Dim</font> fl <font COLOR="#0000ff">As</font> String()<br>
						&nbsp; <font COLOR="#0000ff">Dim</font> Item <font COLOR="#0000ff">As</font> &nbsp;String<br>
						&nbsp; fl = Directory.GetFilesInDirectory(Request.MapPath("."))<br>
						&nbsp; Result.Text = ""</p>
					<p><font COLOR="#0000ff">&nbsp; For</font> <font COLOR="#0000ff">Each</font> Item <font COLOR="#0000ff">
							In</font> fl</p>
					<p>&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">Dim</font> strDirName <font COLOR="#0000ff">
							As</font> <font COLOR="#0000ff">String<br>
						</font>&nbsp;&nbsp;&nbsp; strDirName = Item<br>
						&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">Dim</font> nIndex <font COLOR="#0000ff">As</font>
						<font COLOR="#0000ff">Integer</font></p>
					<p>&nbsp;&nbsp;&nbsp; nIndex = strDirName.IndexOf("\")</p>
					<p><font COLOR="#0000ff">&nbsp;&nbsp;&nbsp; While</font> nIndex &gt;= 0<br>
						&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; strDirName = Right(strDirName, len(strDirName) - 
						nIndex - 1)<br>
						&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; nIndex = strDirName.IndexOf("\")<br>
						&nbsp;&nbsp;&nbsp; <font COLOR="#0000ff">End</font> <font COLOR="#0000ff">While</font></p>
					<p>&nbsp;&nbsp;&nbsp; Result.Text = Result.Text &amp; strDirName &amp; "&lt;br&gt;" 
						&amp; Chr(13) &amp; Chr(10)<br>
						&nbsp; <font COLOR="#0000ff">Next</p>
					</FONT>
					<p><font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Sub</font></p>
				</td>
			</tr>
			<tr>
				<td width="100%"><font COLOR="#0000ff">Sub</font> GetLogicalDrives_Click(<font COLOR="#0000ff">ByVal</font>
					sender <font COLOR="#0000ff">As</font> System.Object, <font COLOR="#0000ff">ByVal</font>
					e <font COLOR="#0000ff">As</font> System.EventArgs)
					<p><font COLOR="#0000ff">&nbsp; Dim</font> strDrives <font COLOR="#0000ff">As</font>
						<font COLOR="#0000ff">String</font>()<br>
						&nbsp; <font COLOR="#0000ff">Dim</font> Item <font COLOR="#0000ff">As</font> <font COLOR="#0000ff">
							String<br>
						</font>&nbsp; strDrives = Directory.GetLogicalDrives()<br>
						&nbsp; Result.Text = ""</p>
					<p><font COLOR="#0000ff">&nbsp; For</font> <font COLOR="#0000ff">Each</font> Item <font COLOR="#0000ff">
							In</font> strDrives<br>
						&nbsp;&nbsp;&nbsp; Result.Text = Result.Text &amp; Item &amp; "&lt;br&gt;" 
						&amp; Chr(13) &amp; Chr(10)<br>
						&nbsp; <font COLOR="#0000ff">Next</p>
					</FONT>
					<p><font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Sub</font></p>
				</td>
			</tr>
			<tr>
				<td width="100%"><font COLOR="#0000ff">Sub</font> CurrentDirectoryInfo_Click(<font COLOR="#0000ff">ByVal</font>
					sender <font COLOR="#0000ff">As</font> System.Object, <font COLOR="#0000ff">ByVal</font>
					e <font COLOR="#0000ff">As</font> System.EventArgs)
					<p><FONT color="black" size="2">Dim strCurrentDir As String = 
							Directory.GetCurrentDirectory()<BR>
							Result.Text = "Current:" &amp; strCurrentDir &amp;&nbsp;vbCrLf<BR>
							Result.Text = Result.Text &amp; "Created: " &amp; 
							Directory.GetCreationTime(strCurrentDir) &amp; vbCrLf<BR>
							Result.Text = Result.Text &amp; "LastAccess: " &amp; 
							Directory.GetLastAccessTime(strCurrentDir).ToFileTime() &amp; vbCrLf<BR>
							Result.Text = Result.Text &amp; "LastWrite: " &amp; 
							Directory.GetLastWriteTime(strCurrentDir).ToFileTime() &amp; vbCrLf<BR>
							<BR>
						</FONT><font COLOR="#0000ff">End</font> <font COLOR="#0000ff">Sub</font></p>
				</td>
			</tr>
		</table>
	</body>
</HTML>
