Imports System.IO

Public Class WebForm2
    Inherits System.Web.UI.Page
    Protected WithEvents Result As System.Web.UI.WebControls.Label
    Protected WithEvents DirectoryName As System.Web.UI.WebControls.TextBox
    Protected WithEvents DirectoryExists As System.Web.UI.WebControls.Button
    Protected WithEvents GetDirsInDir As System.Web.UI.WebControls.Button
    Protected WithEvents GetFilesInDirectory As System.Web.UI.WebControls.Button
    Protected WithEvents GetLogicalDrives As System.Web.UI.WebControls.Button
    Protected WithEvents CurrentDirectoryInfo As System.Web.UI.WebControls.Button
    Protected WithEvents DeleteDirectory As System.Web.UI.WebControls.Button
    Protected WithEvents Button1 As System.Web.UI.WebControls.Button
    Protected WithEvents CreateDirectory As System.Web.UI.WebControls.Button

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Not IsPostBack Then
            Result.Text = "Waiting for user interaction."
        End If
    End Sub

    Private Sub DirectoryExists_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DirectoryExists.Click
        ' Call the code that checks for invalid characters.
        If Not IsPathOK() Then
            Return
        End If

        ' Create the directory path.
        Dim strFilepath As String
        strFilepath = Server.MapPath("UserCreatedDirectories\" & DirectoryName.Text)
        ' Check the existence the directory and catch exceptions.
        Try
            If Directory.Exists(strFilepath) = True Then
                Result.Text = strFilepath & " does exist"
            Else
                Result.Text = strFilepath & " does not exist"
            End If
        Catch ex As Exception
            Result.Text += "Exception: " & ex.Message
        End Try
    End Sub

    Public Function IsPathOK() As Boolean
        Dim strDirectory As String
        strDirectory = DirectoryName.Text
        Result.Text = "The directory you specified has illegal characters."
        If strDirectory.IndexOf("\") >= 0 Then
            Return False
        ElseIf strDirectory.IndexOf("/") >= 0 Then
            Return False
        ElseIf strDirectory.IndexOf(":") >= 0 Then
            Return False
        End If
        Result.Text = ""
        Return True
    End Function

    Private Sub GetDirsInDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetDirsInDir.Click

        ' Dim dl As Directory()
        Dim dl As String()
        ' Dim Item As Directory
        Dim Item As String

        Try

            dl = Directory.GetDirectories(Request.MapPath("UserCreatedDirectories"), "*.*")
            Result.Text = ""

            For Each Item In dl

                Dim strDirName As String
                strDirName = Item
                Dim nIndex As Integer
                nIndex = strDirName.IndexOf("\")
                While nIndex >= 0
                    strDirName = Right(strDirName, Len(strDirName) - nIndex - 1)
                    nIndex = strDirName.IndexOf("\")
                End While

                Result.Text = Result.Text & strDirName & "<br>" & Chr(13) & Chr(10)
            Next
        Catch ex As Exception
            Result.Text = ex.Message
        End Try
    End Sub

    Private Sub GetFilesInDirectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetFilesInDirectory.Click

        ' Dim fl As File()
        Dim fl As String()
        'Dim Item As File
        Dim Item As String
        fl = Directory.GetFiles(Request.MapPath("."))
        Result.Text = ""

        For Each Item In fl

            Dim strDirName As String
            strDirName = Item
            Dim nIndex As Integer
            nIndex = strDirName.IndexOf("\")
            While nIndex >= 0
                strDirName = Right(strDirName, Len(strDirName) - nIndex - 1)
                nIndex = strDirName.IndexOf("\")
            End While

            Result.Text = Result.Text & strDirName & "<br>" & Chr(13) & Chr(10)
        Next
    End Sub

    Private Sub GetLogicalDrives_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetLogicalDrives.Click

        Dim strDrives As String()
        Dim Item As String
        strDrives = Directory.GetLogicalDrives()
        Result.Text = ""

        For Each Item In strDrives

            Result.Text = Result.Text & Item & "<br>" & Chr(13) & Chr(10)
        Next
    End Sub

    Private Sub CurrentDirectoryInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CurrentDirectoryInfo.Click
        Dim strCurrentDir As String = Directory.GetCurrentDirectory()
        Result.Text = "Current:" & strCurrentDir & "<br>" + Chr(13) + Chr(10)
        Result.Text = Result.Text & "Created: " & Directory.GetCreationTime(strCurrentDir) & "<br>" + Chr(13) + Chr(10)
        Result.Text = Result.Text & "LastAccess: " & Directory.GetLastAccessTime(strCurrentDir).ToFileTime() & "<br>" + Chr(13) + Chr(10)
        Result.Text = Result.Text & "LastWrite: " & Directory.GetLastWriteTime(strCurrentDir).ToFileTime() & "<br>" + Chr(13) + Chr(10)
    End Sub

    Private Sub DeleteDirectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteDirectory.Click

        ' Call the code that checks for invalid characters.
        If Not IsPathOK() Then
            Return
        End If

        ' Create the directory path.
        Dim strFilepath As String
        strFilepath = Server.MapPath("UserCreatedDirectories\" & DirectoryName.Text)

        ' Delete the directory and catch exceptions.
        Try
            Directory.Delete(strFilepath)
            Result.Text = "Deleted: " & strFilepath
        Catch ex As Exception
            Result.Text = "Exception: " & ex.Message
        End Try
    End Sub

    Private Sub CreateDirectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateDirectory.Click

        ' Call the code that checks for invalid characthers.
        If Not IsPathOK() Then
            Return
        End If

        ' Create the directory path.
        Dim strFilepath As String
        strFilepath = Server.MapPath("UserCreatedDirectories\" & DirectoryName.Text)

        ' Create the directory and catch exceptions.
        Try
            Directory.CreateDirectory(strFilepath)
            Result.Text = "Created: " & strFilepath
        Catch ex As Exception
            Result.Text = "Exception: " & ex.Message
        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Response.Redirect("/Chapter5/Chapter_5.htm")
    End Sub
End Class
